/*
 * Copyright 1980 Kenneth C. R. C. Arnold and The Regents of the
 * University of California.  Permission is granted to freely
 * distribute curses and its documentation provided that this
 * notice is left intact.
 */

/*
 * Implementation using varargs and vsprintf by John Gilmore.
 * My changes are in the public domain.
 */

#ifndef lint
static char sccsid[] = "@(#)mvprintw.c	5.1 (Berkeley) 6/7/85";
#endif not lint

# include	"curses.ext"
# include	<varargs.h>

/*
 * implement the mvprintw commands.  Due to the variable number of
 * arguments, they cannot be macros.  Sigh....
 *
 */
#ifdef __STDC__
int mvprintw(int x, int y, const char *fmt, ... )
{
	va_list args;
	int ret;

	if (move(y, x) != OK) {
		return ERR;
	}
	
	va_start(args,fmt);

	ret = _sprintw(stdscr, fmt, &args);
	va_end(args);
	return ret;
}

mvwprintw( WINDOW * win,int x, int y, const char * fmt, ...)
{
	va_list args;
	int ret;

	if (wmove(win, y, x) != OK) {
		return ERR;
	}
	va_start(args,fmt);

	ret = _sprintw(win, fmt, &args);
	va_end(args);

	return ret;
}
#else
mvprintw(va_alist)
va_dcl {
	int y, x;
	va_list args;
	char *fmt;
	int ret;

	va_start(args);
	y = va_arg(args, int);
	x = va_arg(args, int);
	if (move(y, x) != OK) {
		va_end(args);
		return ERR;
	}

	fmt = va_arg(args, char *);

	ret = _sprintw(stdscr, fmt, &args);
	va_end(args);
	return ret;
}

mvwprintw(va_alist)
va_dcl {
	int y, x;
	va_list args;
	WINDOW	*win;
	char *fmt;
	int ret;

	va_start(args);
	win = va_arg(args, WINDOW *);
	y = va_arg(args, int);
	x = va_arg(args, int);
	if (wmove(win, y, x) != OK) {
		va_end(args);
		return ERR;
	}

	fmt = va_arg(args, char *);

	ret = _sprintw(win, fmt, &args);
	va_end(args);
	return ret;
}
#endif
