/*
 * Copyright 1980 Kenneth C. R. C. Arnold and The Regents of the
 * University of California.  Permission is granted to freely
 * distribute curses and its documentation provided that this
 * notice is left intact.
 */

/*
 * Implementation using varargs and vsprintf by John Gilmore.
 * My changes are in the public domain.
 */

#ifndef lint
static char sccsid[] = "@(#)printw.c	5.1 (Berkeley) 6/7/85";
#endif not lint

/*
 * printw and friends
 *
 */

# include	"curses.ext"
# include <stdarg.h>

/*
 *	This routine implements a printf on the standard screen.
 */

#ifdef __STDC__
int
printw(const char * fmt ,...)
{
	va_list args;
	int ret;

	va_start(args,fmt);

	ret = _sprintw(stdscr, fmt, &args);
	va_end(args);
	return ret;
}

/*
 *	This routine implements a printf on the given window.
 */
int
wprintw(WINDOW * win,const char * fmt, ...)
{
	va_list args;
	int ret;

	va_start(args,fmt);

	ret = _sprintw(win, fmt, &args);
	va_end(args);
	return ret;
}

/*
 *	This routine actually executes the printf and adds it to the window
 */
int
_sprintw(WINDOW *win, char *fmt, va_list *args)
{
	char	buf[512];	/* Bogus, but what are we to do? */

	(void) vsprintf(buf, fmt, *args);
	return waddstr(win, buf);
}
#else   /* __STDC__ */
# include	<varargs.h>

int
printw(va_alist)
va_dcl {
	va_list args;
	char *fmt;
	int ret;

	va_start(args);
	fmt = va_arg(args, char *);

	ret = _sprintw(stdscr, fmt, &args);
	va_end(args);
	return ret;
}

/*
 *	This routine implements a printf on the given window.
 */
int
wprintw(va_alist)
va_dcl {
	va_list args;
	WINDOW	*win;
	char *fmt;
	int ret;

	va_start(args);
	win = va_arg(args, WINDOW *);
	fmt = va_arg(args, char *);

	ret = _sprintw(win, fmt, &args);
	va_end(args);
	return ret;
}

/*
 *	This routine actually executes the printf and adds it to the window
 */
int
_sprintw(win, fmt, args)
WINDOW	*win;
char	*fmt;
va_list	*args;
{
	char	buf[512];	/* Bogus, but what are we to do? */

	(void) vsprintf(buf, fmt, *args);
	return waddstr(win, buf);
}
#endif
