/*****************************************************************************
                        AGRAPH Include File for C
*****************************************************************************/

#define MAX_X 799            /* maximum X Coordinate */
#define MAX_Y 599           /* maximum Y Coordinate */

#define DARKBLACK     0      /* colors */
#define LIGHTBLACK    1
#define DARKRED       2
#define LIGHTRED      3
#define DARKGREEN     4
#define LIGHTGREEN    5
#define DARKYELLOW	  6
#define LIGHTYELLOW   7
#define DARKBLUE      8
#define LIGHTBLUE     9
#define DARKVIOLETT  10
#define LIGHTVIOLETT 11
#define DARKCYAN     12
#define LIGHTCYAN    13
#define DARKWHITE    14
#define LIGHTWHITE   15
#define REPLACE		  0
#define OR			  1
#define AND			  2
#define EOR			  3

/*************************** ACRTC Calls ************************************/

#ifdef __STDC__

int gr_start(const char *);          /* start graphics ()                           */
extern  gr_end();            /* end   graphics ()                           */
extern  gr_reset();          /* reinitialize ACRTC ()                       */
extern  gr_resetclut();      /* reinitialize CLUT ()                        */
extern  gr_chgscreen();      /* change screen (screen)                      */
extern  gr_enabscreen();     /* enable current screen ()                    */
extern  gr_disabscreen();    /* disable current screen ()                   */
extern  gr_screenstart();    /* set screen start address (x,y)              */
extern  gr_screensize();     /* set screen size (x,y)                       */
extern  gr_bcolor();         /* set background color (color)                */
extern  gr_fcolor();         /* set foreground color (color)                */
extern  gr_colorcomp();      /* set color comparison register (color)       */
extern  gr_edgecolor();      /* set edge color (color)                      */
extern  gr_maskcolor();      /* set color mask (color)                      */
extern  gr_cliparea();       /* set clip area (xmin,ymin,xmax,ymax)         */
extern  gr_pattzoom();       /* set pattern zoom (x,y)                      */
extern  gr_pattpntr();       /* set pattern pointers (x,y)                  */
extern  gr_pattblock();      /* set pattern block (xs,ys,xe,ye)             */
extern  gr_setpatt();        /* set pattern ram (pointer)                   */
extern  gr_org();            /* set origin (x,y)                            */
extern  gr_scandir();        /* set scan direction (sdir,ddir)              */
extern  gr_modifymode();     /* set modify mode (mmode)                     */
extern  gr_areamode();       /* set area mode (amode)                       */
extern  gr_colormode();      /* set color mode (colmode)                    */
extern  gr_opmode();         /* set operation mode (opmode)                 */
extern  gr_clear();          /* clear video frame (color)                   */
extern  gr_setrwp();         /* set read write pointer (linadr)             */
extern  gr_readbuf();        /* read from frame buffer (pointer,count)      */
extern  gr_writebuf();       /* write to frame buffer  (pointer,count)      */
extern  gr_modifybuf();      /* modify frame buffer    (pointer,count)      */
extern  gr_dot();            /* draw one dot ()                             */
extern  gr_amove();          /* absolute move (x,y)                         */
extern  gr_rmove();          /* relative move (x,y)                         */
extern  gr_aline();          /* absolute line (x,y)                         */
extern  gr_rline();          /* relative line (x,y)                         */
extern  gr_arct();           /* absolute rectangle (x,y)                    */
extern  gr_rrct();           /* absolute rectangle (x,y)                    */
extern  gr_apll();           /* absolute polyline (n,pointer)               */
extern  gr_rpll();           /* relative polyline (n,pointer)               */
extern  gr_aplg();           /* absolute polygone (n,pointer)               */
extern  gr_rplg();           /* relative polygone (n,pointer)               */
extern  gr_circle();         /* circle (radius)                             */
extern  gr_elps();           /* ellipse (a,b,dx)                            */
extern  gr_aarc();           /* absolute arc (xc,yc,xe,ye)                  */
extern  gr_rarc();           /* relative arc (xc,yc,xe,ye)                  */
extern  gr_aearc();          /* absolute ellipse arc (a,b,xc,yc,xe,ye)      */
extern  gr_rearc();          /* relative ellipse arc (a,b,xc,yc,xe,ye)      */
extern  gr_afrct();          /* absolute filled rectangle (x,y)             */
extern  gr_rfrct();          /* relative filled rectangle (x,y)             */
extern  gr_paint();          /* paint area ()                               */
extern  gr_agcpy();          /* absolute graphic copy (xs,ys,dx,dy)         */
extern  gr_rgcpy();          /* relative graphic copy (xs,ys,dx,dy)         */
extern  gr_text();           /* paint text ("abc")                          */
extern  gr_textsize();       /* set text size (x,y)                         */
extern  gr_textdir();        /* set text direction (slant,dir);             */
extern  gr_chargen();        /* select character generator (cg)             */
extern  gr_circledir();      /* set circle direction (cd)                   */
extern  gr_drawpatt();       /* draw contents of pattern ram (sx,sy)        */
extern  gr_gcon();           /* graphic cursor ON ()                        */
extern  gr_gcoff();          /* graphic cursor OFF ()                       */
extern  gr_gcwindow();       /* set graph curs window (minx,maxx,miny,maxy) */
extern  gr_gcsize();         /* set graphic cursor size (xsize,ysize)       */
extern  gr_gccolor();        /* set graphic cursor color (bcolor,fcolor)    */
extern  gr_gcpattern();      /* set graphic cursor pattern (patt)           */
extern  gr_gcaset();         /* set graphic cursor absolute (x,y)           */
extern  gr_gcrset();         /* set graphic cursor relative (x,y)           */
extern  gr_readclut();       /* read color of colornumber                   */
extern  gr_writeclut();      /* write color to CLUT (adr,red,green,blue)    */
extern  gr_clutmask();       /* write CLUT color mask (mask)                */
extern  gr_acrtcstat();      /* get ACRTC status ()                         */
extern  gr_waitacrtc();      /* wait for ACRTC to finish & get status ()    */
extern  gr_clrard();         /* clear ARD flag in status register SR ()     */
extern  gr_getbcolor();      /* get background color (&color)               */
extern  gr_getfcolor();      /* get foreground color (&color)               */
extern  gr_getcolorcomp();   /* get color comparison reg (&color)           */
extern  gr_getedgecolor();   /* get edge color (&color)                     */
extern  gr_getmaskcolor();   /* get mask color (&color)                     */
extern  gr_getrwp();         /* get read/write pointer (&rwp)               */
extern  gr_getdp();          /* get drawing pointer (&dp)                   */
extern  gr_getcp();          /* get current pointer (&x,&y)                 */
extern  gr_windowpos();		 /* set window position					        */
extern  gr_blink();			 /* set blink mode								*/
extern  gr_blinktime();      /* set blink time                              */
extern  gr_blinkoff();       /* set blink off                               */
extern  gr_bscreenzoom();    /* set Base Screen Zooom                       */
/*************************** MOUSE Calls ************************************/

extern  ms_getpos();         /* get mouse position (&x,&y)                  */
extern  ms_getkey();         /* get mouse key status (&lkey,&mkey,&rkey)    */
extern	ms_start();			 /* init mouse */
extern  ms_end();			 /* deinit mouse */
#else
extern  gr_start();          /* start graphics ()                           */
extern  gr_end();            /* end   graphics ()                           */
extern  gr_reset();          /* reinitialize ACRTC ()                       */
extern  gr_resetclut();      /* reinitialize CLUT ()                        */
extern  gr_chgscreen();      /* change screen (screen)                      */
extern  gr_enabscreen();     /* enable current screen ()                    */
extern  gr_disabscreen();    /* disable current screen ()                   */
extern  gr_screenstart();    /* set screen start address (x,y)              */
extern  gr_screensize();     /* set screen size (x,y)                       */
extern  gr_bcolor();         /* set background color (color)                */
extern  gr_fcolor();         /* set foreground color (color)                */
extern  gr_colorcomp();      /* set color comparison register (color)       */
extern  gr_edgecolor();      /* set edge color (color)                      */
extern  gr_maskcolor();      /* set color mask (color)                      */
extern  gr_cliparea();       /* set clip area (xmin,ymin,xmax,ymax)         */
extern  gr_pattzoom();       /* set pattern zoom (x,y)                      */
extern  gr_pattpntr();       /* set pattern pointers (x,y)                  */
extern  gr_pattblock();      /* set pattern block (xs,ys,xe,ye)             */
extern  gr_setpatt();        /* set pattern ram (pointer)                   */
extern  gr_org();            /* set origin (x,y)                            */
extern  gr_scandir();        /* set scan direction (sdir,ddir)              */
extern  gr_modifymode();     /* set modify mode (mmode)                     */
extern  gr_areamode();       /* set area mode (amode)                       */
extern  gr_colormode();      /* set color mode (colmode)                    */
extern  gr_opmode();         /* set operation mode (opmode)                 */
extern  gr_clear();          /* clear video frame (color)                   */
extern  gr_setrwp();         /* set read write pointer (linadr)             */
extern  gr_readbuf();        /* read from frame buffer (pointer,count)      */
extern  gr_writebuf();       /* write to frame buffer  (pointer,count)      */
extern  gr_modifybuf();      /* modify frame buffer    (pointer,count)      */
extern  gr_dot();            /* draw one dot ()                             */
extern  gr_amove();          /* absolute move (x,y)                         */
extern  gr_rmove();          /* relative move (x,y)                         */
extern  gr_aline();          /* absolute line (x,y)                         */
extern  gr_rline();          /* relative line (x,y)                         */
extern  gr_arct();           /* absolute rectangle (x,y)                    */
extern  gr_rrct();           /* absolute rectangle (x,y)                    */
extern  gr_apll();           /* absolute polyline (n,pointer)               */
extern  gr_rpll();           /* relative polyline (n,pointer)               */
extern  gr_aplg();           /* absolute polygone (n,pointer)               */
extern  gr_rplg();           /* relative polygone (n,pointer)               */
extern  gr_circle();         /* circle (radius)                             */
extern  gr_elps();           /* ellipse (a,b,dx)                            */
extern  gr_aarc();           /* absolute arc (xc,yc,xe,ye)                  */
extern  gr_rarc();           /* relative arc (xc,yc,xe,ye)                  */
extern  gr_aearc();          /* absolute ellipse arc (a,b,xc,yc,xe,ye)      */
extern  gr_rearc();          /* relative ellipse arc (a,b,xc,yc,xe,ye)      */
extern  gr_afrct();          /* absolute filled rectangle (x,y)             */
extern  gr_rfrct();          /* relative filled rectangle (x,y)             */
extern  gr_paint();          /* paint area ()                               */
extern  gr_agcpy();          /* absolute graphic copy (xs,ys,dx,dy)         */
extern  gr_rgcpy();          /* relative graphic copy (xs,ys,dx,dy)         */
extern  gr_text();           /* paint text ("abc")                          */
extern  gr_textsize();       /* set text size (x,y)                         */
extern  gr_textdir();        /* set text direction (slant,dir);             */
extern  gr_chargen();        /* select character generator (cg)             */
extern  gr_circledir();      /* set circle direction (cd)                   */
extern  gr_drawpatt();       /* draw contents of pattern ram (sx,sy)        */
extern  gr_gcon();           /* graphic cursor ON ()                        */
extern  gr_gcoff();          /* graphic cursor OFF ()                       */
extern  gr_gcwindow();       /* set graph curs window (minx,maxx,miny,maxy) */
extern  gr_gcsize();         /* set graphic cursor size (xsize,ysize)       */
extern  gr_gccolor();        /* set graphic cursor color (bcolor,fcolor)    */
extern  gr_gcpattern();      /* set graphic cursor pattern (patt)           */
extern  gr_gcaset();         /* set graphic cursor absolute (x,y)           */
extern  gr_gcrset();         /* set graphic cursor relative (x,y)           */
extern  gr_readclut();       /* read color of colornumber                   */
extern  gr_writeclut();      /* write color to CLUT (adr,red,green,blue)    */
extern  gr_clutmask();       /* write CLUT color mask (mask)                */
extern  gr_acrtcstat();      /* get ACRTC status ()                         */
extern  gr_waitacrtc();      /* wait for ACRTC to finish & get status ()    */
extern  gr_clrard();         /* clear ARD flag in status register SR ()     */
extern  gr_getbcolor();      /* get background color (&color)               */
extern  gr_getfcolor();      /* get foreground color (&color)               */
extern  gr_getcolorcomp();   /* get color comparison reg (&color)           */
extern  gr_getedgecolor();   /* get edge color (&color)                     */
extern  gr_getmaskcolor();   /* get mask color (&color)                     */
extern  gr_getrwp();         /* get read/write pointer (&rwp)               */
extern  gr_getdp();          /* get drawing pointer (&dp)                   */
extern  gr_getcp();          /* get current pointer (&x,&y)                 */
extern  gr_windowpos();		 /* set window position					        */
extern  gr_blink();			 /* set blink mode								*/
extern  gr_blinktime();      /* set blink time                              */
extern  gr_blinkoff();       /* set blink off                               */
extern  gr_bscreenzoom();    /* set Base Screen Zooom                       */
/*************************** MOUSE Calls ************************************/

extern  ms_getpos();         /* get mouse position (&x,&y)                  */
extern  ms_getkey();         /* get mouse key status (&lkey,&mkey,&rkey)    */
extern	ms_start();			 /* init mouse */
extern  ms_end();			 /* deinit mouse */
#endif
