/* dcmd.h - direct command definitions */


/* this is the structure that is passed to the getstat and putstat
 * routines.
 */
typedef struct d_cmd { 
	int  dcmdsync,		/* sink code - must be DCMDSYNC */
	     manager,		/* file manager code,  pd_dtype from _gs_opts() */
	     device;		/* device type code */
	void *dcmdblk;		/* device driver specific command */
} *Dcmd;

/* 
 *  General definitions
 */
 
#define DCMDSYNC   0xCA7CA11		/* this code validates the command block */

/* device type codes:
 *    These are specific to the devices.  The drivers can use this
 *    field to validate that the call that arrived is for the device
 *    that they control.
 */
#define SCSIdevice 0x5C51	/* SCSI bus device */

