/* structure for manipulating OS-9 directories in a (more)
	transportable manner.  The method and names work like
	the BSD4.2 directory calls


   Prototyping neu : Fr. 15.04.1994 22:30:10 -mte
*/

#ifndef _dir_h
#define _dir_h 1

#define MAXNAMLEN 32
#define DIRBLKSIZ 256

struct direct {
	long	d_addr;				/* fildes address (no inodes on OS-9) */
	short	d_reclen;			/* (not used) */
	short	d_namlen;			/* (not used) */
	char	d_name[MAXNAMLEN+1];/* directory entry name */
};

typedef struct _dirdesc {
	int		dd_fd;				/* fd for open directory */
	long	dd_loc;				/* (not used) */
	long	dd_size;			/* (not used) */
	char	dd_buf[DIRBLKSIZ];	/* buffer for directory entry */
} DIR;


#ifdef   __STDC__

	int chdir(const char *dirname);
	int chxdir(const char *dirname);

	DIR *opendir(const char *dirname);
	struct direct *readdir(DIR *dirp);
	long telldir(DIR *dirp);
	void seekdir(DIR *dirp, long loc);
	void rewinddir(DIR *dirp);
	void closedir(DIR *dirp);

#else    /* __STDC__*/ 

	int chdir();
	int chxdir();

	DIR *opendir();
	struct direct *readdir();
	long telldir();
	void seekdir();
	void rewinddir();
	void closedir();

#endif   /* __STDC__*/ 
#endif

