/*
	os9 signal handler zur Emulation der 'UNIX Signal' Funktion
	
	(c) h+t 21.9.90
	Do. 16.06.1994 09:49:17  mh

*/

#ifndef __OS9SIGN__
#define __OS9SIGN__

#define _NSIG        32
#define NSIG		_NSIG

#define SIGALARM	10				/* time out signal nr 	*/
#define SIGALRM		SIGALARM  		/* UNIX Name 			*/
#define SIGSTOP     12     			/* suspended    		*/

/* #define SIGTSTP     18     */ /* weckt die tshell    */


/*  noch zu implementierende Signale */

#define SIGFPE		11     /* Floating point exeption */

/*#define SIGTERM		SIGQUIT */  /* aus: signal.h  */

/* zugehoeriges file: /dd/cwork/utils/os9signalh.c */

#ifdef __STDC__
/* Type of a signal handler.  */
typedef void (*__sighandler_t)(int);

__sighandler_t signal (int, __sighandler_t );
long alarm( long zeit );	/* nach zeit sekunden wird SIGALARM ausgel. */
                        /* ist zeit == 0, wird alarm ausgetragen    */
                        /* wenn bit 31 gesetzt: Zeit in tics!!      */
                        /* returnwert : -1 == Fehler; oder alarmID   */
long ralarm( long zeit );/* nach zeit Sekunden wird zyklisch SIGALARM ausgel. */
                        /* ist zeit == 0, wird alarm ausgetragen    */
                        /* wenn bit 31 gesetzt: Zeit in tics!!      */
                        /* returnwert : -1 == Fehler; oder alarmID   */
int alarm_del(int alarmID);  /* einen alarm austragen */                        

#else
typedef int (*__sighandler_t)();
extern __sighandler_t signal();
extern int alarm(/* long zeit */);	/* nach zeit sekunden wird SIGALARM ausgel. */
extern int ralarm(/* long zeit */);	/* nach zeit sekunden wird zyklisch SIGALARM ausgel. */
extern int alarm_del(/* int alarmID*/);  /* einen alarm austragen */                        
#endif

#define SIG_DFL	((__sighandler_t)0)		/* default signal handling */
#define SIG_IGN	((__sighandler_t)1)		/* ignore signal */
#define SIG_ERR	((__sighandler_t)-1)	/* error return from signal */


#endif
/*------------ ende von os9signal.h ------------*/


