/* Version Mi. 17.11.1993 23:30:46 
		Mo. 21.03.1994 13:33:37
*/
	/* type lengths regardless of compiler in use:
    "char" for 8 bits
    "WORD" for 16 bits
    "long" for 32 bits */

#ifndef STDIO
#define STDIO
typedef short WORD;     /* always 16 bits */

#define _ERROR_ (-1)

#define _READ		1
#define _WRITE		2
#define _UNBUF		4
#define _BIGBUF		8
#define _EOF		0x10
#define _ERR		0x20
#define _SCF		0x40
#define _RBF		0x80
#define _DEVMASK	0xc0
#define _WRITTEN	0x0100		/*	buffer written in update mode  */
#define _MYBUF		0x0200		/*	system allocated buffer  */
#define _INIT		0x8000		/*	_iob initialized  */

#define EOF (-1)
#define EOL 13
#ifndef NULL
#define NULL 0
#endif

#ifdef OSK
#define PMODE READ|WRITE    /* r/w for owner */
#else
#define PMODE  0xb          /* r/w for owner, r for others */
#endif



#ifndef __size_t
#  define __size_t 1
   typedef unsigned long size_t;   /* from <stddef.h> */
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define _ARGS(args) args
#else
#define _ARGS(args) ()
#endif


#define FOPEN_MAX     _G_FOPEN_MAX
#define FILENAME_MAX _G_FILENAME_MAX
#define TMP_MAX 999 /* Only limited by filename length */

#define L_ctermid     9
#define L_cuserid     9
#ifdef _OSK
#define P_tmpdir      "/dd/TMP"
#else
#define P_tmpdir      "/tmp"
#endif
#define L_tmpnam      200

/* For use by debuggers. These are linked in if printf or fprintf are used. */
#ifndef __GNUC__
/*	the following are fake pointer variable defintions  */
typedef struct _iobuf {
    char *_ptr,		/* buffer pointer */
         *_base,	/* buffer base address */
         *_end;		/* buffer end address */
    WORD _flag;		/* file status */
    WORD _fd;		/* file path number */
    char _save;		/* for 'ungetc' when unbuffered */
    WORD _bufsiz;	/* size of data buffer */
	int (*_ifunc)();/* function to use for input */
	int (*_ofunc)();/* function to use for output */
} FILE;

#ifdef OSK
#   define BUFSIZ 512
#   define _NFILE 32
#else
#   ifdef OS9
#       define BUFSIZ 256
#       define _NFILE 16
#   endif
#endif

extern FILE _iob[_NFILE];


#define stdin	(&_iob[0])
#define stdout	(&_iob[1])
#define stderr	(&_iob[2])

#define ferror(p)       ((p)->_flag&_ERR)
#define feof(p)         ((p)->_flag&_EOF)
#define clearerr(p)     ((p)->_flag&=~_ERR)
#define cleareof(p)     ((p)->_flag&=~_EOF)
#define fileno(p)       ((p)->_fd)
#define remove			unlink	


#define fgetc           getc
#define fputc			putc
#define putchar(c)      putc(c,stdout)
#define getchar()       getc(stdin)





#else   /* GNU-C  */

#if !defined(_GNU_C_1) && !defined(GCC257)


#define _STDIO_H
#define _STDIO_USES_IOSTREAM

#ifndef BUFSIZ
#define BUFSIZ 1024
#endif

#define _IOFBF 0 /* Fully buffered. */
#define _IOLBF 1 /* Line buffered. */
#define _IONBF 2 /* No buffering. */




#include <libio.h>



typedef struct _IO_FILE FILE;

extern FILE *stdin, *stdout, *stderr; /* TODO */
typedef _IO_fpos_t fpos_t;

#define stdin _IO_stdin
#define stdout _IO_stdout
#define stderr _IO_stderr

#define getc(fp) _IO_getc(fp)
#define putc(c, fp) _IO_putc(c, fp)
#define putchar(c) putc(c, stdout)
#define getchar() getc(stdin)

extern void clearerr _ARGS((FILE*));
extern int feof _ARGS((FILE*));
extern int ferror _ARGS((FILE*));
extern int fileno _ARGS((FILE*));

#else  /* GNU_C 1  */

/*	the following are fake pointer variable defintions  */
typedef struct _iobuf {
    char *_ptr,		/* buffer pointer */
         *_base,	/* buffer base address */
         *_end;		/* buffer end address */
    WORD _flag;		/* file status */
    WORD _fd;		/* file path number */
    char _save;		/* for 'ungetc' when unbuffered */
    WORD _bufsiz;	/* size of data buffer */
	int (*_ifunc)();/* function to use for input */
	int (*_ofunc)();/* function to use for output */
} FILE;

#ifdef OSK
#   define BUFSIZ 512
#   define _NFILE 32
#else
#   ifdef OS9
#       define BUFSIZ 256
#       define _NFILE 16
#   endif
#endif

extern FILE _iob[_NFILE];


#define stdin	(&_iob[0])
#define stdout	(&_iob[1])
#define stderr	(&_iob[2])

#define ferror(p)       ((p)->_flag&_ERR)
#define feof(p)         ((p)->_flag&_EOF)
#define clearerr(p)     ((p)->_flag&=~_ERR)
#define cleareof(p)     ((p)->_flag&=~_EOF)
#define fileno(p)       ((p)->_fd)
#define remove			unlink	


#define fgetc           getc
#define fputc			putc
#define putchar(c)      putc(c,stdout)
#define getchar()       getc(stdin)

#endif

#endif





#ifdef __STDC__

#ifndef __GNUC__



  /* stehen in gcc2/stdlib.h */
  
int    read(int,char  * , int);
int    write(int,const char  * , int);
int    close (int);
int    creat(const char *, short);
int    create(const char *, short,short,long);
int    open( const char *,int);
int    putc( int, FILE *);
int    getc (FILE *);
#endif
/* int rename(const char *old, const char *new); ANSI-VERSION*/ 
/* int rename(const char *new, const char *old);  OSK-Version*/ 
#else

#define const /* */
#define volatile /* */

extern int kbhit(), _iordy();
#endif

#if !defined (_GNU_C_1) && !defined(GCC257)	
extern int fgetpos _ARGS((FILE* fp, fpos_t *pos));
extern int fsetpos _ARGS((FILE* fp, const fpos_t *pos));
extern int fprintf _ARGS((FILE*, const char* format, ...));
extern int printf _ARGS((const char* format, ...));
extern int scanf _ARGS((const char* format, ...));
extern int sprintf _ARGS((char*, const char* format, ...));
extern int sscanf _ARGS((const char* string, const char* format, ...));
extern int vfprintf _ARGS((FILE *fp, char const *fmt0, _G_va_list));
extern int vprintf _ARGS((char const *fmt, _G_va_list));
extern int vsprintf _ARGS((char* string, const char* format, _G_va_list));
extern int __underflow _ARGS((struct _IO_FILE*));
extern int __overflow _ARGS((struct _IO_FILE*, int));
#endif

int    kbhit _ARGS((void)), _iordy _ARGS((int ));
extern int fclose _ARGS((FILE*));
extern int fflush _ARGS((FILE*));
extern int fgetc _ARGS((FILE *));
extern char* fgets _ARGS((char*, int, FILE*));
extern FILE* fopen _ARGS((const char*, const char*));
extern int fputc _ARGS((int, FILE*));
extern int fputs _ARGS((const char *str, FILE *fp));
extern size_t fread _ARGS((void*, size_t, size_t, FILE*));
extern FILE* freopen _ARGS((const char*, const char*, FILE*));
extern int fscanf _ARGS((FILE *fp, const char* format, ...));
extern int fseek _ARGS((FILE* fp, long int offset, int whence));
extern long int ftell _ARGS((FILE* fp));
extern size_t fwrite _ARGS((const void*, size_t, size_t, FILE*));
extern char* gets _ARGS((char*));
extern void perror _ARGS((const char *));
extern char *puts _ARGS((const char *str));
extern int remove _ARGS((const char*));
extern int rename _ARGS((const char* _old, const char* _new));
extern void rewind _ARGS((FILE*));
extern void setbuf _ARGS((FILE*, char*));
extern void setlinebuf _ARGS((FILE*));
extern void setbuffer _ARGS((FILE*, char*, int));
extern int setvbuf _ARGS((FILE*, char*, int mode, size_t size));
extern FILE* tmpfile _ARGS((void));
extern char* tmpnam _ARGS((char*));
extern int ungetc _ARGS((int c, FILE* fp));

#if !defined(__STRICT_ANSI__) || defined(_POSIX_SOURCE)
extern FILE *fdopen _ARGS((int, const char *));
extern FILE* popen _ARGS((const char*, const char*));
extern int pclose _ARGS((FILE*));
#endif


#ifdef __cplusplus
}
#endif





/* Constants suitable for use as the third argument 
   to the "fseek" function. -mte- 
*/
#ifndef SEEK_CUR
#define SEEK_CUR 1
#define SEEK_END 2
#define SEEK_SET 0
#endif
/*

Konstanten fuer setvbuf:

*/
#ifndef _IOFBF
#define _IOFBF  0
#define _IOLBF  1
#define _IONBF  2
#endif


#endif 

