/* H+T stdlib        So. 03.11.1991 12:54:45 */
/*   angepasst von:      */
/* stdlib.h: ANSI X3.159 1989 library header, section 4.10 */
/* Copyright (C) Codemist Ltd. */
/* Copyright (C) Inmos Ltd. 1989 */
/* version 0.02 */

#ifndef __stdlib_h
#define __stdlib_h


#ifndef __size_t
#  define __size_t 1
   typedef unsigned int size_t;   /* from <stddef.h> */
#endif

#ifndef __wchar_t
   typedef int wchar_t;           /* from <stddef.h> */
#  define __wchar_t 1
#endif

#ifdef __STDC__

#ifndef NULL
#  define NULL (void *)0                  /* from <stddef.h> */
#endif

typedef struct div_t { int quot, rem; } div_t;

typedef struct ldiv_t { long int quot, rem; } ldiv_t;

#define RAND_MAX 0x7fffffff

double atof(const char * /*nptr*/);
int atoi(const char * /*nptr*/);
long int atol(const char * /*nptr*/);
double strtod(const char * /*nptr*/, char ** /*endptr*/);
long int strtol(const char * /*nptr*/, char ** /*endptr*/, int /*base*/);
unsigned long int strtoul(const char * /*nptr*/,
                                       char ** /*endptr*/, int /*base*/);
int rand(void);
void srand(unsigned int /*seed*/);
void *calloc(size_t /*nmemb*/, size_t /*size*/);
void free(const void * /*ptr*/);
void *malloc(size_t /*size*/);
void *realloc(void * /*ptr*/, size_t /*size*/);
void abort(void);
int  atexit(void (* /*func*/)(void));
void exit(int /*status*/);
char *getenv(const char * /*name*/);
int  system(const char * /*string*/);
void *bsearch(const void *key, const void * /*base*/,
              size_t /*nmemb*/, size_t /*size*/,
              int (* /*compar*/)(const void *, const void *));
void qsort(void * /*base*/, size_t /*nmemb*/, size_t /*size*/,
           int (* /*compar*/)(const void *, const void *));
int abs(int /*j*/);
div_t div(int /*numer*/, int /*denom*/);
long int labs(long int /*j*/);
ldiv_t ldiv(long int /*numer*/, long int /*denom*/);
int mblen(const char * /*s*/, size_t /*n*/);
int mbtowc(wchar_t * /*pwc*/, const char * /*s*/, size_t /*n*/);
int wctomb(char * /*s*/, wchar_t /*wchar*/);
size_t mbstowcs(wchar_t * /*pwcs*/, const char * /*s*/, size_t /*n*/);
size_t wcstombs(char * /*s*/, const wchar_t * /*pwcs*/, size_t /*n*/);
char *puts( const char *);
char * tmpnam( char * s);

int os9fork( const char * , int, const char *, short , short, int, short); 
int os9forkc( const char * , int, const char *, short , short, int, short, short); 






#else   /* __STDC__ */

#ifndef NULL
#  define NULL 0                  /* from <stddef.h> */
#endif
typedef struct div_t { int quot, rem; } div_t;

typedef struct ldiv_t { long int quot, rem; } ldiv_t;

#define RAND_MAX 0x7fffffff

extern double atof();
extern int atoi();
extern long int atol();
extern double strtod();
extern long int strtol();
extern unsigned long int strtoul();
extern int rand();
extern void srand();
extern char *calloc();
extern void free();
extern char *malloc();
extern char *realloc( );
extern void abort();
extern int  atexit();
extern void exit( );
extern char *getenv( );
extern int  system( );
extern char *bsearch( );
extern void qsort( );
extern int abs( );
extern div_t div( );
extern long int labs( );
extern ldiv_t ldiv( );
extern int mblen( );
extern int mbtowc( );
extern int wctomb( );
extern size_t mbstowcs( );
extern size_t wcstombs( );
extern char *puts( );

#endif    /* __STDC__  */

#ifndef bcopy
#define bcopy(a,b,c)   memcpy(b,a,c);
#endif
#endif

/* end of stdlib.h */
