/****************************************************************************
**
**  Datei  : /dd/defs/string.h
**  Datum  : Do. 16.04.1992 17:58:14
**  Projekt: C
**  Autor  : Martin Hoehle + Michael Tettinger
**  (c) hoehle + tettinger 1992
**---------------------------------------------------------------------------
**  Includefile 
**---------------------------------------------------------------------------
**  Update : Do. 16.04.1992 17:58:44 -mte- memcpy(),memset(),memchr()
**           Fr. 19.11.1993 23:09:09 -mte- strncat()
*****************************************************************************/  

#ifndef __STRING__
#define __STRING__

#ifndef __stdlib_h
#include <stdlib.h>
#endif
#ifndef NULL
#define NULL	0
#endif


/*  strchr sucht das erste vorkommen des zeichens 'c' im string 's' */
#ifdef __STDC__
	char * 	strcat(char *, const char *);
	char * 	strncat(char *s1, const char *s2, int n);

	char * 	strncpy(char *, const char *,int);
	char *	strpbrk(char *s1, const char *s2);

	char * 	index (const char *s, char c);
	char * 	rindex(const char *s, char c);
	int 	strcmp(const char *, const char *);
	int 	strncmp(const char *, const char *, int);
	char * 	strcpy(char *, const char *);
	int 	strlen( const char *);
	char * 	strncpy(char *, const char *,int);

	void * 	memcpy(void *dest, const void *src, size_t size );
	int   	memcmp(const void *dest, const void *src, size_t size );
	void * 	memchr(const void *s, int val, size_t size );
	void *  memset(void *s, int val, size_t size );

	int findstr(int,const char *, const char *);
	int strspn(const char *s1, const char *s2);
	int strcspn(const char *s1, const char *s2);
	
	char * strdup( const char *);
	char * strsave( const char *);

	int  _cpymem(short int pid, size_t size ,  const void *src, void *dest );
	int	tolower(int);
	int	toupper(int);
	
#else  /* __STDC__  */

extern	 	char * index ();
extern	 	char * rindex();
extern	 	int strcmp();
extern	 	int strncmp();
extern	  	char * strcpy();
extern	  	int strlen( );
extern	  	char * strcat();
extern		char * strncat();

extern	  	char * strncpy();
extern		int findstr();
extern		char *strpbrk();
extern		int strspn();
extern		int strcspn();
extern   	char * strdup( );
extern   	char * strsave( );


extern	void  memcpy();
extern	int   memcmp();
extern	void* memchr();
extern	void*  memset();

extern  int  _cpymem( );

#endif  /* __STDC__   */

#ifndef memmove
#define memmove memcpy		/* Unter OS-9 memcpy erlaubt ueberlappende Bereiche */
#endif

#define strchr index
#define strrchr rindex

#define strsave strdup

#ifndef bcopy
#define bcopy(a,b,c)   memcpy(b,a,c)
#endif
#ifndef bcmp
#define bcmp(a,b,c)   memcmp(a,b,c)
#endif
#ifndef bzero
#define bzero(a,b)   memset(a,0,b)
#endif

#endif

/* ende von string.h  */
