/*------------------------------------------------------------------!
! Tape Header Structures											!
!------------------------------------------------------------------*/
#ifndef TAPEHEAD

#include <time.h>

#define VERSION		1
#define SYNCCODE	0xCA7FECE5

typedef struct tapefentry {
	u_int32		fe_posn;		/* file position on the tape		*/
	u_int32		fe_size;		/* file size (in bytes)				*/
	u_int32		fe_crc;			/* file CRC							*/
	u_int32		fe_rsvd[5];		/* reserved for possible future use	*/
	char		fe_name[32];	/* file name string					*/
} fentry, *Fentry;

typedef struct tape_header {
	u_int32		th_sync;		/* sync header: 0xCA7FECE5			*/
	u_int32		th_vers;		/* tapeboot version id				*/
	struct sgtbuf th_time;		/* system time stamp				*/
	u_char		th_rsvd[2];		/* reserved							*/
	char		th_volid[32];	/* volume name						*/
	char		th_targid[32];	/* target system id name string		*/
								/* if tb_idataddsiz = 0, non disk image	*/
	fentry		th_bootentry;	/* bootstrap file entry				*/
	fentry		th_idataentry;	/* initialized data file entry		*/
	u_int32		th_idataddsiz;	/* DD_TOT field of data file		*/
	u_int32		th_fentries;	/* # of additional file entries to	*/
								/* follow immediately after header	*/
	u_int32		th_padded[10];	/* reserved							*/
} tape_header, *Tape_header;

#define TAPEHEAD
#endif
