/*  tcap.h:

*/

#ifdef __STDC__
#ifndef _STDC__
#define _STDC__
#endif
#endif


/*  Configuration options   */

#ifndef FALSE

#define FALSE   0               /* False, no, bad, etc.         */
#endif

#ifndef TRUE
#define TRUE    1               /* True, yes, good, etc.        */
#endif

#if defined(V7) | defined(USG) | defined(BSD) | defined(OSK)
#define PATHCHR ':'
#else
#define PATHCHR ';'
#endif

/*
 * The program communicates with the display using a high level interface. A
 * "TERM" structure holds useful variables, and indirect pointers to routines
 * that do useful operations. The low level get and put routines are here too.
 * This lets a terminal, in addition to having non standard commands, have
 * funny get and put character code too. The calls might get changed to
 * "termp->t_field" style in the future, to make it possible to run more than
 * one terminal type.
 */
#ifdef _STDC__
typedef struct  {
        short   t_nrow;                     /* Number of rows.              */
        short   t_ncol;                     /* Number of columns.           */
        short   t_margin;                   /* min margin for extended lines*/
        short   t_scrsiz;                   /* size of scroll region "      */
        int t_pause;                        /* # times thru update to pause */
        void    (*t_open)(void);            /* Open terminal at the start.  */
        void    (*t_close)(void);           /* Close terminal at end.       */
        void    (*t_kopen)(void);           /* Open keyboard at the start.  */
        void    (*t_kclose)(void);          /* Close keyboard at end.       */
        int     (*t_getchar)(void);         /* Get character from keyboard. */
        void    (*t_putchar)(int ch);       /* Put character to display.    */
        void    (*t_flush)(void);           /* Flush output buffers.        */
        void    (*t_move)(int row, int col); /* Move the cursor, origin 0.   */
        void    (*t_eeol)(void);            /* Erase to end of line.        */
        void    (*t_eeop)(void);            /* Erase to end of page.        */
        void    (*t_clrs)(void);            /* Erase           page.        */
        void    (*t_beep)(void);            /* Beep.                        */
        void    (*t_rev)(int state);        /* set reverse video state      */
        void    (*t_insl)(void);            /* insert line */
        void    (*t_dell)(void);            /* delete line */
        void    (*t_attr2)(int state);      /* attribut 2 selektiere fuer Marker (z.B. half video) */
        void    (*t_attr3)(int state);      /* attribut 3 selektiere fuer Bloecke (z.B. half video) */
                        /*----------*/
        void    (*t_setfor)(int color);     /* set forground color          */
        void    (*t_setback)(int color);    /* set background color         */
        void    (*t_teilsc)(int,int,int);   /* teilscroll durchfuehren (top,bottom,anz)*/
        void    (*t_halfi)(int state);      /* set half intensity video state      */
		void	(*t_bcol)(int , int );		/* set for and background col.*/
		int		(*t_chrr)(void);			/* test for char. ready       */
	    void	(*t_curs)(int);  			/* make cursor on / off       */
}       TERM;
#else
typedef struct  {
    short   t_nrow;                 /* Number of rows.              */
    short   t_ncol;                 /* Number of columns.           */
    short   t_margin;               /* min margin for extended lines*/
    short   t_scrsiz;               /* size of scroll region "      */
    int     t_pause;                /* # times thru update to pause */
    void    (*t_open)();            /* Open terminal at the start.  */
    void    (*t_close)();           /* Close terminal at end.       */
    void    (*t_kopen)();           /* Open keyboard at the start.  */
    void    (*t_kclose)();          /* Close keyboard at end.       */
    int     (*t_getchar)();         /* Get character from keyboard. */
    void    (*t_putchar)();         /* Put character to display.    */
    void    (*t_flush)();           /* Flush output buffers.        */
    void    (*t_move)();            /* Move the cursor, origin 0.   */
    void    (*t_eeol)();            /* Erase to end of line.        */
    void    (*t_eeop)();            /* Erase to end of page.        */
    void    (*t_clrs)();            /* Erase           page.        */
    void    (*t_beep)();            /* Beep.                        */
    void    (*t_rev)();				/* set reverse video state      */
    void    (*t_insl)();        	/* insert line */
    void    (*t_dell)();        	/* delete line */
    void    (*t_attr2)();       /* attribut 2 selektiere fuer Marker (z.B. half video) */
    void    (*t_attr3)();       /* attribut 3 selektiere fuer Bloecke (z.B. half video) */
                               /*----------*/
    void    (*t_setfor)();      /* set forground color          */
    void    (*t_setback)();     /* set background color         */
        /* ----- Neu 11/91 ---------------- */
    void    (*t_teilsc)();           /* teilscroll durchfuehren      */
    void    (*t_halfi)();            /* set half intensity      */
	void	(*t_bcol)();			/* set for and background col.*/
	int		(*t_chrr)();			/* test for char. ready       */
    void	(*t_curs)();			/* make cursor on / off       */
    
}       TERM;
#endif
/*  TEMPORARY macros for terminal I/O  (to be placed in a machine
                        dependant place later)  */
#define TTopen      (*term.t_open)
#define TTclose     (*term.t_close)
#define TTkopen     (*term.t_kopen)
#define TTkclose    (*term.t_kclose)
#define TTgetc      (*term.t_getchar)
#define TTputc      (*term.t_putchar)
#define TTflush     (*term.t_flush)
#define TTmove      (*term.t_move)
#define TTeeol      (*term.t_eeol)
#define TTbeep      (*term.t_beep)
#define TTrev       (*term.t_rev)
#define TTrez       (*term.t_rez)
#define clrscr		(*term.t_clrs)
#define TTforg      (*term.t_setfor)
#define TTbacg      (*term.t_setback)
#define TTcls       (*term.t_clrs)
#define TThint		(*term.t_halfi)
#define TTbcol		(*term.t_bcol)
#define TTchrr		(*term.t_chrr)
#define TTcurs		(*term.t_curs)
#define TTteilsc	(*term.t_teilsc)
#define TTattr2		(*term.t_attr2)
                                                                        
extern	int	eolexist;			/* does clear to EOL exist?		*/
extern	int	flickcode;			/* do flicker supression?		*/
extern int	teilscexist;		/* Teilscroll exist	    		*/
extern int	dellineexist;		/* delete line exist			*/
extern int	illineexist;		/* insert line exist			*/
extern int	attr2exist ;		/* attribute 2 existiert exist	*/
extern int	attr3exist ;		/* attribute 2 existiert exist	*/
extern int	memmapped  ;		/* memory mapped video          */
extern	int	revexist;			/* does reverse video exist?	*/

extern TERM term;
/* ------------------------------ ende von tcap.h ------------------------------  */


