/*-------------------------------------------------------------------*/
/* Datei   : tsys.h                                                  */
/* Project : tshell                                                  */
/*-------------------------------------------------------------------*/
/* Datum   : 25.11.1988  mte                                         */
/*-------------------------------------------------------------------*/
/* Bescchreibung:													 */
/*		Systemabhaengige Structuren fuer die keine Includefiles		 */
/*		vorliegen													 */
/*-------------------------------------------------------------------*/
/* Update  :														 */
/*-------------------------------------------------------------------*/

typedef struct __ssascf{
	long 				v_port;		/* Device base adress			*/
	short				v_lprc;		/* Last aktive process ID		*/
	short				v_busy;		/* Active process ID			*/
	short				v_wake;		/* Process ID to awaken			*/
	long				v_path;		/* Linked list of open paths	*/
	char				res1[0x20];
	struct	__ssascf	*v_dev2;	/* Adress of attached device	*/
									/* static storage				*/
	char				v_type;		/* Device Type or parity		*/
	char				v_line;		/* Lines left until end of page */
	char				v_paus;		/* Pause request				*/
	char				v_intr;		/* Keyboard Interrupt character */
	char				v_quit;		/* Keyboard Abort character		*/
	char				v_pchr;		/* Pause character				*/
	char				v_err;		/* Error accumulator			*/
	char				v_xon;		/* X-ON character				*/
	char				v_xoff;		/* X-OFF character				*/
	char				res2[0x18];
	char				v_varStart;	/* Device Driver Variables 		*/
									/* begin here					*/
	} SSASCF;
	
	
typedef struct __deviceTable {
	long				moduleHeader;	/* Adresse des Moduleheaders	*/
	SSASCF				*staticStorageArea; /* Adresse der Static Storage */
										/* Area 						*/
										/* Rest ist derzeit noch unbekannt */
	} DEVICETABLE;

/* ======================= End of tsys.h ============================*/
